//registerOutputEvent("Player", "Clone", "", 0);

function Player::clone(%pl)
{
	if(!isObject(%pl) || !isObject(%cl = %pl.client) || isObject(%cl.clone))
		return;
	%pi = 3.1415926;
	%pl = %cl.player;
	%vect = %pl.getForwardVector();
	%angle = mAtan(getWord(%vect, 0), getWord(%vect, 1));
	%angle += %pi/2;	//If you want to spawn the bot on the left side of the player, change this to %angle -= %pi/2;
	%vectX = mSin(%angle);
	%vectY = mCos(%angle);
	%scale = mSqrt(mPow(%vectX, 2) + mPow(%vectY, 2));
	%dist = 5;	//Change this to be however far away from the player you want
	%mod = %dist/%scale;
	%vectX *= %mod;
	%vectY *= %mod;
	%x = getWord(%pl.position, 0) + %vectX;
	%y = getWord(%pl.position, 1) + %vectY;
	%z = getWord(%pl.position, 2);
	%betaCl = new ScriptObject()
	{
		accent = %cl.accent;
		accentColor = %cl.accentColor;
		chest = %cl.chest;
		chestColor = %cl.chestColor;
		decalName = %cl.decalName;
		faceName = %cl.faceName;
		hat = %cl.hat;
		hatColor = %cl.hatColor;
		headColor = %cl.headColor;
		hip = %cl.hip;
		hipColor = %cl.hipColor;
		isClone = 1;
		larm = %cl.larm;
		larmColor = %cl.larmColor;
		lhand = %cl.lhand;
		lhandColor = %cl.lhandColor;
		lleg = %cl.lleg;
		llegColor = %cl.llegColor;
		pack = %cl.pack;
		packColor = %cl.packColor;
		secondPack = %cl.secondPack;
		secondPackColor = %cl.secondPackColor;
		rarm = %cl.rarm;
		rarmColor = %cl.rarmColor;
		rhand = %cl.rhand;
		rhandColor = %cl.rhandColor;
		rleg = %cl.rleg;
		rlegColor = %cl.rlegColor;
	};
	%bot = (%betaCl.player = new AIPlayer()
	{
		client = %betaCl;
		datablock = PlayerStandardArmor.getID();
		position = %x SPC %y SPC %z;
		rotation = %pl.rotation;
	});
	GameConnection::applyBodyParts(%betaCl);
	GameConnection::applyBodyColors(%betaCl);
	%bot.setAimObject(%pl);
	%bot.setMoveObject(%pl);
	%bot.cloneMoveLoop(%cl);
	%bot.owner = %cl;
	%cl.clone = %betaCl;
	if(isObject(%mini = %cl.minigame))
		%betaCl.minigame = %mini;
	return %bot;
}

function AIPlayer::cloneMoveLoop(%bot, %cl)
{
	if(!isObject(%bot) || %bot.getState() $= "DEAD" || !isObject(%cl))
		return;
	%bot.schedule(50, "cloneMoveLoop", %cl);
	if(!isObject(%cl.player) || %cl.player.getState() $= "DEAD")
	{
		%bot.stop();
		%bot.setMoveX(0);
		%bot.setMoveY(0);
		%bot.setAimObject(0);
		%bot.setMoveObject(0);
		return;
	}
	%pl = %cl.player;
	%respectfulDist = 10;	//How far the bots follow you at.
	%tooCloseDist = 3;
	%health = mFloatLength(100-(%bot.getDamagePercent()*100), 1);
	if(%health <= 35)
	{
		if(!%bot.badlyInjured)
			servercmdAlarm(%bot.client);
		%bot.badlyInjured = 1;
	}
	else
		%bot.badlyInjured = 0;
	if((%dist = vectorDist(getWords(%bot.position, 0, 1) SPC 0, getWords(%pl.position, 0, 1) SPC 0)) <= %tooCloseDist)
	{
		//%cl.bottomPrint("\c6Clone Status: Running; "@%health@"% health.", 3);
		%bot.setMoveX(0);
		%bot.setMoveY(-10);
		%bot.setAimObject(%pl);
		%bot.setMoveObject(%pl);
	}
	else if(%dist <= %respectfulDist)
	{
		//%cl.bottomPrint("\c6Clone Status: Stopped; "@%health@"% health.", 3);
		%bot.setMoveX(0);
		%bot.setMoveY(0);
		%bot.setAimObject(%pl);
	}
	else
	{
		//%cl.bottomPrint("\c6Clone Status: Following; "@%health@"% health.", 3);
		%bot.setMoveX(0);
		%bot.setMoveY(10);
		%bot.setAimObject(%pl);
		%bot.setMoveObject(%pl);
	}
}

package Clone
{
	function GameConnection::createPlayer(%cl, %trans)
	{
		if(%cl.isClone)
		{
			%betaCl.player = new AIPlayer()
			{
				client = %betaCl;
				datablock = PlayerStandardArmor.getID();
				position = getWords(%trans, 0, 2);
				rotation = getWords(%trans, 3, 6);
			};
			servercmdUpdateBodyParts(%betaCl,
				%betaCl.hat,
				%betaCl.accent,
				%betaCl.armor,
				%betaCl.secondPack,
				%betaCl.chest,
				%betaCl.hip,
				%betaCl.lleg,
				%betaCl.rleg,
				%betaCl.larm,
				%betaCl.rarm,
				%betaCl.lhand,
				%betaCl.rhand);
			servercmdUpdateBodyColors(%betaCl,
				%betaCl.headColor,
				%betaCl.hatColor,
				%betaCl.accentColor,
				%betaCl.packColor,
				%betaCl.secondPackColor,
				%betaCl.chestColor,
				%betaCl.hipColor,
				%betaCl.llegColor,
				%betaCl.rlegColor,
				%betaCl.larmColor,
				%betaCl.rarmColor,
				%betaCl.lhandColor,
				%betaCl.rhandColor,
				%betaCl.decalName,
				%betaCl.faceName);
			%bot = %betaCl.player;
			%bot.setAimObject(%cl.player);
			%bot.setMoveObject(%cl.player);
			%bot.cloneMoveLoop(%cl);
			%bot.owner = %cl;
		}
		else
			Parent::createPlayer(%cl, %trans);
	}
	
	function servercmdJoinMinigame(%cl, %mini)
	{
		Parent::servercmdJoinMinigame(%cl);
		if(isObject(%cl.clone))
			%cl.clone.minigame = %mini;
	}
};
activatePackage("Clone");